{$X+,G+,R+}
program TheMindWorker;
uses Crt, Graph, Dos, Utils, Mouse;

{--------------------------}
{Tipos usados pelo programa}
{--------------------------}
type
    LimiteType  = array [1..2] of Integer;
    RespType    = array [0..3] of Byte;
    Grelhas     = array [1..5,1..5] of Char;
    Sequencia   = (Tab1, Tab2, Tab3, Tab4);
    Stages      = (Nivel1, Nivel2, Nivel3, Nivel4, Nivel5);
    BonusLetter = array [1..2] of byte;
    MsgTipo     = String [15];

const
     BgiPath = 'd:\tp\bgi';
     HelpPath = '.\mind.hlp';

{----------------}
{Variveis globais}
{----------------}
var
   GraphDriver,               { Driver do Modo Grafico. }
   GraphMode   : Integer;     { Modo Grafico Actual.    }
   Saida       : Boolean;     { Indica Se Se Pode Sair. }
   IsMouse     : Boolean;     { Indica se o utilizador  }
                              { escolheu usar o rato.   }
   SafeExit    : Pointer;     { Guarda Temporariamente  }
                              { O Valor De ExitProc.    }

{-------------------------------------------------}
{Esta e a subrotina Segundos. Nao recebe variaveis}
{Tem como funcao devolver os segundos no instante }
{em que e chamada                                 }
{-------------------------------------------------}
function Segundos:Longint;
var
   Horas,
   Minutos,
   Seg,
   Centesimos : Word;

begin
  GetTime (Horas, Minutos, Seg, Centesimos);     {*Obtencao da Hora*}
  Segundos := Horas * 3600 + Minutos * 60 + Seg; {*Devolve-se em   *}
end;                                                  {*segundos        *}


{--------------------------------------------}
{Esta subrotina e Converte. Recebe como dados}
{um numero a ser convertido.                 }
{Tem como funcao colocar '0' nos espacos em  }
{branco.                                     }
{--------------------------------------------}
function  Converte (Numero:Word):String;
var
   Temp : String;
   I    : Byte;

begin
  Str (Numero:6,Temp);           {*Converte o numero para string*}
  for I := 1 to Length(Temp) do  {*Coloca 0 onde tem ' '        *}
    if Temp [I] = ' ' then
         Temp [I]:= '0';
  Converte := Temp;
end;


{-------------------------------------------------------}
{Esta rotina e MouseInput. Recebe como variaveis, dados }
{relativos a situacao actual do jogo,para assim realizar}
{a sua accao.                                           }
{O seu  objectivo e actuar como equivalente da rotina   }
{KeybInput mas para o rato.                             }
{-------------------------------------------------------}
procedure MouseInput (Tabuleiro: Sequencia; Nivel:Stages;var Posicao:RespType);
var
   TempoIni,
   Tempo,Temp      : LongInt;
   YPos, XPos      : array [0..5] of Word;
   Left,
   Middle,
   Right,
   Saida,
   Sair            : Boolean;
   I               : Byte;
   X, Y,
   IncreVert,
   IncreHoriz      : Word;

begin
  {*Decisao do tempo de resposta permitido tendo em atencao a situacao*}
  {*do jogo                                                           *}
  case  Tabuleiro  of
        Tab1       : case Nivel of
                         Nivel1..Nivel3 : Tempo := 100;
                         Nivel4, Nivel5 : Tempo := 90;
                     end;

        Tab2       : case Nivel of
                         Nivel1..Nivel3 : Tempo := 80;
                         Nivel4, Nivel5 : Tempo := 70;
                     end;

        Tab3       : Tempo := 50;
  end;
  IncreHoriz:=(539 - 100) Div (Ord(Tabuleiro)+3);
  IncreVert:=(410 - 110) Div (Ord(Tabuleiro)+3);
  for I:= 0 to Ord(Tabuleiro)+3 do
     XPos [I] := 100 + IncreHoriz * I;
  for I:= 0 to Ord(Tabuleiro)+3 do
     YPos [I] := 110 + IncreVert * I;
  TempoIni := Segundos; I := 0;

  SetColor (WHITE);
  SetTextStyle (SANSSERIFFONT,HORIZDIR,3);
  OutTextXy (100,440, 'Indica as coordenadas da(s) letra(s)');
  ShowCursor;
  Saida := False;
  repeat
    Sair := False;
     repeat
       MouseStatus (Left,Middle,Right,X,Y);
       if Left then
          Sair := True;
    until Sair and not Left;
    if Sair and (X>XPos[0]) and (X<XPos[Ord(Tabuleiro)+3]) and (Y>YPos[0]) and
       (Y<YPos[Ord(Tabuleiro)+3]) then
     begin
       if (X>=XPos[0]) and (X<XPos[1]) then
       begin
        if (Y>=YPos[0]) and (Y<YPos[1]) then
          begin
            Posicao[I] := 1;
            Posicao[I+1] := 1;
          end
        else
         if (Y>=YPos[1]) and (Y<YPos[2]) then
          begin
            Posicao[I] := 1;
            Posicao[I+1] := 2;
          end
         else
          if (Y>=YPos[2]) and (Y<YPos[3]) then
           begin
             Posicao[I] := 1;
             Posicao[I+1] := 3;
           end
          else
           if (Y>=YPos[3]) and (Y<YPos[4]) then
            begin
              Posicao[I] := 1;
              Posicao[I+1] := 4;
            end
           else
            if (Y>=YPos[4]) and (Y<YPos[5]) then
             begin
               Posicao[I] := 1;
               Posicao[I+1] := 5;
             end;
       end
       else
        if (X>=XPos[1]) and (X<XPos[2]) then
        begin
         if (Y>=YPos[0]) and (Y<YPos[1]) then
          begin
            Posicao[I] := 2;
            Posicao[I+1] := 1;
          end
         else
          if (Y>=YPos[1]) and (Y<YPos[2]) then
           begin
            Posicao[I] := 2;
            Posicao[I+1] := 2;
           end
          else
           if (Y>=YPos[2]) and (Y<YPos[3]) then
            begin
             Posicao[I] := 2;
             Posicao[I+1] := 3;
            end
           else
            if (Y>=YPos[3]) and (Y<YPos[4]) then
             begin
              Posicao[I] := 2;
              Posicao[I+1] := 4;
             end
            else
             if (Y>=YPos[4]) and (Y<YPos[5]) then
              begin
               Posicao[I] := 2;
               Posicao[I+1] := 5;
              end;
        end
        else
         if (X>=XPos[2]) and (X<XPos[3]) then
         begin
          if (Y>=YPos[0]) and (Y<YPos[1]) then
           begin
            Posicao[I] := 3;
            Posicao[I+1] := 1;
           end
          else
           if (Y>=YPos[1]) and (Y<YPos[2]) then
            begin
              Posicao[I] := 3;
             Posicao[I+1] := 2;
            end
           else
            if (Y>=YPos[2]) and (Y<YPos[3]) then
             begin
              Posicao[I] := 3;
              Posicao[I+1] := 3;
             end
            else
             if (Y>=YPos[3]) and (Y<YPos[4]) then
              begin
                Posicao[I] := 3;
                Posicao[I+1] := 4;
              end
             else
              if (Y>=YPos[4]) and (Y<YPos[5]) then
               begin
                 Posicao[I] := 3;
                 Posicao[I+1] := 5;
               end;
         end
         else
          if (X>=XPos[3]) and (X<XPos[4]) then
          begin
           if (Y>=YPos[0]) and (Y<YPos[1]) then
            begin
              Posicao[I] := 4;
              Posicao[I+1] := 1;
            end
           else
            if (Y>=YPos[1]) and (Y<YPos[2]) then
             begin
               Posicao[I] := 4;
               Posicao[I+1] := 2;
             end
            else
             if (Y>=YPos[2]) and (Y<YPos[3]) then
              begin
                Posicao[I] := 4;
                Posicao[I+1] := 3;
              end
             else
              if (Y>=YPos[3]) and (Y<YPos[4]) then
               begin
                 Posicao[I] := 4;
                 Posicao[I+1] := 4;
               end
              else
               if (Y>=YPos[4]) and (Y<YPos[5]) then
                begin
                  Posicao[I] := 4;
                  Posicao[I+1] := 5;
                end;
           end
           else
            if (X>=XPos[4]) and (X<XPos[5]) then
             if (Y>=YPos[0]) and (Y<YPos[1]) then
              begin
                Posicao[I] := 5;
                Posicao[I+1] := 1;
              end
             else
              if (Y>=YPos[1]) and (Y<YPos[2]) then
               begin
                 Posicao[I] := 5;
                 Posicao[I+1] := 2;
               end
              else
               if (Y>=YPos[2]) and (Y<YPos[3]) then
                begin
                  Posicao[I] := 5;
                  Posicao[I+1] := 3;
                end
               else
                if (Y>=YPos[3]) and (Y<YPos[4]) then
                 begin
                   Posicao[I] := 5;
                   Posicao[I+1] := 4;
                 end
                else
                 if (Y>=YPos[4]) and (Y<YPos[5]) then
                  begin
                    Posicao[I] := 5;
                    Posicao[I+1] := 5;
                  end;

       if Tabuleiro = Tab1 then
          Saida := True
       else
          if Sair and (I = 2) then
           Saida := True
          else
           Inc (I,2);
     end;
     Left := False;
  until (Segundos>=TempoIni+Tempo) or Saida;
  HideCursor;
  if not Saida then
     FillChar (Posicao,4,0);
  SetColor (GREEN);
  OutTextXy (100,440, 'Indica as coordenadas da(s) letra(s)');
end;



{-------------------------------------------------------}
{Esta rotina e KeybInput. Recebe como variaveis, dados  }
{relativos a situacao actual do jogo,para assim realizar}
{a sua accao.                                           }
{O seu  objectivo e actuar como 'parser' da introducao  }
{do utilizador.                                         }
{-------------------------------------------------------}
procedure  KeybInput (Tabuleiro: Sequencia; Nivel:Stages;var Posicao:RespType);
var
   Maximo,
   Grelhas, J : Byte;
   TempoIni,
   Tempo,Temp      : LongInt;

begin
  while KeyPressed do ReadKey;
  SetColor (WHITE);
  SetTextStyle (SANSSERIFFONT,HORIZDIR,3);
  OutTextXy (100,440, 'Indica as coordenadas da(s) letra(s)');


  {*Decisao do tempo de resposta permitido tendo em atencao a situacao*}
  {*do jogo                                                           *}
  case  Tabuleiro  of
        Tab1       : begin
                       case Nivel of
                         Nivel1..Nivel3 : Tempo := 30;
                         Nivel4, Nivel5 : Tempo := 25;
                       end;
                       Maximo := 3;
                     end;

        Tab2       : begin
                       case Nivel of
                         Nivel1..Nivel3 : Tempo := 20;
                         Nivel4, Nivel5 : Tempo := 15;
                       end;
                       Maximo := 4;
                     end;

        Tab3       : begin
                       Tempo := 10;
                       Maximo := 5;
                     end;

        Tab4       : begin
                       Tempo := 10;
                       Maximo := 3;
                       Grelhas := 6;
                     end;
  end;
  TempoIni := Segundos;
  J := 0;
  FillChar (Posicao,4,0);
  repeat                    {*Obtem a resposta do utilizador*}
    if  KeyPressed then     {*Durante o tempo permitido*}
       begin
         Posicao [J] := Abs (Ord(ReadKey)-48);
         Inc (J);
       end;
       Temp := Segundos;
  until (Temp>=TempoIni+Tempo) or ((Tabuleiro=Tab1) and (J=2))
        or ((Tabuleiro in [Tab2..Tab3]) and (J=4))
        or ((Tabuleiro=Tab4) and (J=3));


  {*Se nao teve tempo de introduzir todas as coordenas*}
  if (J<2) or ((J<3) and (Tabuleiro in [Tab2..Tab4])) or
     ((J<4) and (Tabuleiro in [Tab2..Tab3])) then
    FillChar (Posicao, 4, 0)
  else
    {*Se teve tempo vamos ver se sao validas*}
    if  Tabuleiro = Tab4 then
      begin
        if not ((Posicao[0] in [1..Maximo]) and (Posicao[1] in [1..Maximo])
               and (Posicao[2] in [1..Grelhas])) then
           FillChar (Posicao, 4, 0);
      end
    else
      if not ((Posicao[0] in [1..Maximo]) and (Posicao[1] in [1..Maximo])) then
        FillChar (Posicao, 4, 0);
   SetColor (GREEN);
   OutTextXy (100,440, 'Indica as coordenadas da(s) letra(s)');
end;

{---------------------------------------------------}
{Esta e a rotina DesTab. Recebe como variaveis dados}
{referentes ao tipo de tabuleiro a desenhar.        }
{A sua funcao e desenhar a grelha para o tabuleiro  }
{em questao.                                        }
{---------------------------------------------------}
procedure DesTab ( X1,Y1,X2,Y2        :Integer;
                   Tabuleiro          :Sequencia);

var
   I : Byte;
   IncreVert,
   IncreHoriz  : Integer;

begin
    {*Desenha o tabuleiro*}
    SetLineStyle (SOLIDLN, 0, THICKWIDTH);
    SetFillStyle (SOLIDFILL, WHITE);
    IncreHoriz:=(X2 - X1) Div (Ord(Tabuleiro)+3);
    IncreVert:=(Y2 - Y1) Div (Ord(Tabuleiro)+3);
    SetColor (WHITE);
    Bar3D (X1,Y1,X2,Y2,10,TopOn);
    SetColor (BLUE);
    Rectangle (X1,Y1,X2,Y2);
    {*Coloca os tracos no tabuleiro*}
    for I:= 1 to Ord(Tabuleiro)+3 do
        Line (X1+IncreHoriz*I,Y1,X1+IncreHoriz*I,Y2);
    for I:= 1 to Ord(Tabuleiro)+3 do
        Line (X1,Y1+IncreVert*I,X2,Y1+IncreVert*I);
    SetLineStyle (SolidLn, 0, NormWidth);
end;



{-------------------------------------------------}
{ Esta rotina tem a funcao de colocar a numeracao }
{ no tabuleiro.                                   }
{-------------------------------------------------}
procedure Cabecalho (Tabuleiro : Sequencia);
var
   Posicoes : string;
   I        : Byte;
   IncX, IncY,
   XPos, YPos, Temp : Word;

begin
  SetColor (YELLOW);
  case  Tabuleiro  of
        Tab1       : begin
                       IncX := 146;
                       IncY := 100;
                       XPos := 145;
                       YPos := 405;
                       Posicoes := '123';
                     end;

        Tab2       : begin
                       IncX := 109;
                       IncY := 75;
                       XPos := 120;
                       YPos := 405;
                       Posicoes := '1234';
                    end;

        Tab3      :  begin
                       IncX := 85;
                       IncY := 60;
                       XPos := 135;
                       YPos := 405;
                       Posicoes := '12345';
                     end;
  end;
  SetTextStyle ( Triplexfont,HORIZDIR,UserCharSize);
  SetUserCharSize(5, 1, 2, 3);
  Temp := XPos;
  for I := 1 to Length (Posicoes) do
   begin
     OutTextXy (XPos, YPos,Posicoes [I]);
     XPos := XPos + IncX ;
   end;
  SetUserCharSize(1, 1, 3, 1);
  XPos := Temp-95;
  YPos:=YPos-310;
  for I := 1 to Length (Posicoes) do
    begin
      OutTextXy (XPos, YPos, Posicoes [I]);
      YPos := YPos + IncY;
    end;
end;





{----------------------------------------------------}
{Esta e a rotina DisPlay. Recebe como variaveis dados}
{referentes ao estado actual do jogo.                }
{A sua funcao e desenhar o ecran do jogo para o nivel}
{actual.                                             }
{----------------------------------------------------}
procedure DisPlay (Tabuleiro      :Sequencia;
                   Nivel	  :Stages;
                   Player, Computer :Word);

begin
   {*Desenho das margens do ecran do jogo*}
   ClearDevice;
   SetBkColor (BLUE);
   SetFillStyle(SOLIDFILL, GREEN);
   Bar (0,0,639,90);
   Rectangle (0,0,639,90);
   Bar (0,429,639,479);
   Rectangle (0,429,639,479);
   SetFillStyle(SOLIDFILL, WHITE);
   Bar (6,45,106,85);
   Rectangle (6,45,106,85);
   Bar (533,45,633,85);
   Rectangle (533,45,633,85);
   Bar (181,45,281,85);
   Rectangle (181,45,281,85);
   Bar (357,45,457,85);
   Rectangle (357,45,457,85);

   {*Informacao para o utilizador*}
   SetTextStyle(SANSSERIFFONT, HORIZDIR, 3);
   SetColor (WHITE);
   OutTextXY (6,5,'COMPUTER');
   OutTextXY (197,5,'TABEL');
   OutTextXY (377,5,'LEVEL');
   OutTextXY (545,5,'PLAYER');
   SetColor  (CYAN);
   OutTextXY (12,50,Converte (Computer));
   OutTextXY (187,50,Converte(Ord(Tabuleiro)+1));
   OutTextXY (363,50,Converte(Ord(Nivel)+1));
   OutTextXY (538,50,Converte(Player));
   SetColor (RED);

   {*Desenha-se o tabuleiro correspondente*}
   case Tabuleiro of

        Tab1:begin
                DesTab (100,110,539,410,Tab1);
             end;

        Tab2:begin
                DesTab (100,110,539,410,Tab2);
             end;

        Tab3:begin
                DesTab (100,110,539,410,Tab3);
             end;
   end;
   if not IsMouse then
     Cabecalho (Tabuleiro);

end;

{------------------------------------------------}
{Esta e a rotina Baralha1_3. Recebe variaveis que}
{dizem respeito ao estado do jogo actual.        }
{Tem como funcao produzir o tabuleiro para os    }
{tabuleiros 1, 2 e 3.                            }
{------------------------------------------------}
procedure Baralha1_3 (Tabuleiro:Sequencia;var Linhas, Colunas:String;
                      var Matriz:Grelhas; var Bonus:BonusLetter);
var
   Code			: Integer;
   Valido		: Boolean;
   NumMaxLetras,
   LetPerComb,
   I,J,K,MaxComb,
   Indice,X,Y	        : Byte;
   LinhasT,
   ColunasT,
   Letras,Letra	        : String;

begin
  Randomize;
  {*Inicializar as variaveis com os valores correspondentes a situacao*}
  {*actual do jogo                                                    *}
  case Tabuleiro of
     Tab1       :  begin
                     NumMaxLetras := 5;
                     LetPerComb := 2;
                     MaxComb := 4;
                   end;
     Tab2       :  begin
                     NumMaxLetras := 6;
                     LetPerComb := 3;
                     MaxComb := 5;
                   end;
     Tab3       :  begin
                     NumMaxLetras := 9;
                     LetPerComb := 3;
                     MaxComb := 8;
                   end;
  end;

  {*Obtencao das coordenadas para o quadro actual*}
  Colunas := ''; Linhas := '';
  for I:= 1 to Ord(Tabuleiro) + 3 do
    for J:= 1 to Ord(Tabuleiro) + 3 do
      begin
        Colunas := Colunas + Chr (48 + J);
        Linhas := Linhas + Chr (48 + I);
      end;
  LinhasT := Linhas;
  ColunasT := Colunas;
  Letras := '';

  {*Obtencao das letras para o quadro actual*}
  for I:= 1 to NumMaxLetras do
    begin
      repeat
        Letra := Chr(Random (26) + 65);
        J := 1;
        Valido := True;
        while (Length (Letras)>=J) and Valido do
          begin
            if Letras [J] = Letra then
              Valido := False;
            Inc (J);
          end;
      until Valido;
      Letras := Letras + Letra;
    end;

  {*Inicializacao do quadro do nivel actual*}
  for I:= 1 to MaxComb do
    for J:=1 to LetPerComb  do
      begin
        Indice := Random (Length(Colunas)) + 1;
        Val (Colunas [Indice], X, Code);
        Val (Linhas [Indice], Y, Code);
        Matriz [X, Y] := Letras [I];
        Delete (Colunas, Indice, 1);
        Delete (Linhas, Indice, 1);
      end;
  Val (Colunas [1], X, Code);
  Val (Linhas [1], Y, Code);
  Matriz [X, Y] := Letras [Length(Letras)];
  Bonus [1] := X;
  Bonus [2] := Y;
  Linhas := LinhasT;
  Colunas := ColunasT;
end;


{---------------------------------------------------------}
{Esta rotina e ShowLetra. Recebe como parametros dados que}
{indicam a situacao actual do jogo para a rotina defenir o}
{seu comportamento.                                       }
{Tem como funcao mostrar uma letra  durante um certo tempo}
{excepto no caso de receber o valor true para descanso.   }
{Nesse caso coloca a letra no ecran                       }
{---------------------------------------------------------}
procedure ShowLetra (X,Y:Byte;Letra:Char;Tabuleiro:Sequencia;
                     Nivel:Stages;Apaga:Boolean);
var
   Tempo,
   IncX,
   IncY,
   XPos,
   YPos,I,J   : Word;

begin
  {*Inicializa-se as variaveis com os valores para a situacal actual*}
  {*do jogo                                                         *}
  case  Tabuleiro  of
        Tab1       : begin
                       case Nivel of
                         Nivel1..Nivel3 : Tempo := 30;
                         Nivel4, Nivel5 : Tempo := 25;
                       end;
                       IncX := 146;
                       IncY := 100;
                       XPos := 145;
                       YPos := 100;
                       SetTextStyle(TRIPLEXFONT,HORIZDIR,9);
                     end;

        Tab2       : begin
                       case Nivel of
                         Nivel1..Nivel3 : Tempo := 20;
                         Nivel4, Nivel5 : Tempo := 15;
                       end;
                       IncX := 109;
                       IncY := 75;
                       XPos := 120;
                       YPos := 100;
                       SetTextStyle(TRIPLEXFONT,HORIZDIR,8);
                    end;

        Tab3      :  begin
                       Tempo := 10;
                       IncX := 85;
                       IncY := 60;
                       XPos := 135;
                       YPos := 108;
                       SetTextStyle(TRIPLEXFONT,HORIZDIR,6);
                     end;
  end;

  {*Determina-se a posicao da letra*}
  for  I := 1 to X-1 do
     XPos := XPos + IncX;
  for  J := 1 to Y-1 do
     YPos := YPos + IncY;
  {*Printa-se a letra*}
  OutTextXy (XPos, YPos, Letra);
  {*Se Apaga for True apaga-se a letra que foi visualizada*}
  if  Apaga  then
    begin
      Delay (Tempo*100);
      SetColor (WHITE);
      OutTextXy (XPos, YPos, Letra);
    end
  else
      Delay (500);
end;

{-----------------------------------------------}
{Esta e a subrotina Jogar. Nao recebe parametros}
{A sua funcao e coordenar o jogo.               }
{-----------------------------------------------}
procedure  Jogar;
var
   Tabuleiro : Sequencia;
   Nivel     : Stages;
   Computer,
   Player    : Word;
   Saida     : Boolean;
   Linhas,
   Colunas   : String;
   Matriz    : Grelhas;
   Code      : Integer;
   Indice,
   X,Y       : Byte;
   Resposta  : RespType;
   Sucesso   : Boolean;
   Bonus     : BonusLetter;
   Conjunto  : set of char;

begin
  {*Inicializa os dados referentes ao inicio do jogo*}
  Tabuleiro := Tab2;
  Nivel     := Nivel1;
  Computer  := 0;
  Player    := 0;
  Saida     := False;
  Conjunto  := [];
  repeat
    Conjunto := [];
    {*Inicializa os dados para o nivel actual*}
    Display (Tabuleiro, Nivel,Player,Computer);
    Baralha1_3 (Tabuleiro,Linhas,Colunas,Matriz,Bonus);
    repeat
      {*Mostra uma letra no ecran durante um certo tempo*}
      {*e em seguida e lida a resposta do utilizador    *}
      Indice := Random (Length (Colunas)) + 1;
      Val (Colunas [Indice], X, Code);
      Val (Linhas [Indice], Y, Code);
      SetColor (RED);
      ShowLetra (X, Y, Matriz [X, Y], Tabuleiro, Nivel, True);
      if Matriz[X,Y] in Conjunto then
       begin
        if not IsMouse then
           KeybInput (Tabuleiro, Nivel, Resposta)
        else
           MouseInput (Tabuleiro, Nivel, Resposta);
        SetTextStyle (TRIPLEXFONT,HORIZDIR,2);
        {*Se a resposta foi invalida*}
        if Resposta [0] = 0 then
          begin
            Inc (Computer);
            MakeSound (520,300);
            Bar (6,45,106,85);
            Rectangle (6,45,106,85);
            SetColor (CYAN);
            OutTextXy (12,50,Converte(Computer));
          end
        else    {*A resposta foi valida, entao vamos ver se ele acertou*}
          begin {*na letra                                             *}
            Sucesso := False;
            case Tabuleiro of
                 Tab1       : if (Matriz[X,Y]=Matriz[Resposta[0],Resposta[1]])
                               and ((Resposta[0]<>X) or (Resposta[1]<>Y)) then
                                 Sucesso := True
                            else
                                if (Bonus[1]=Resposta[0]) and
                                   (Bonus[2]=Resposta[1]) and
                                   (X=Bonus[1]) and (Y=Bonus[2]) then
                                  begin
                                    Sucesso := True;
                                    Inc (Player, 3);
                                  end;
               Tab2,
               Tab3       : if (Matriz[X,Y]=Matriz[Resposta[0],Resposta[1]])
                             and (Matriz[X,Y]=Matriz[Resposta[2],Resposta[3]])
                             and ((Resposta[0]<>X) or (Resposta[1]<>Y))
                             and ((Resposta[2]<>X) or (Resposta[3]<>Y))
                             then
                               Sucesso := True
                            else
                                if (Bonus[1]=Resposta[0]) and
                                   (Bonus[2]=Resposta[1]) and
                                   (Bonus[1]=Resposta[2]) and
                                   (Bonus[2]=Resposta[3]) and
                                   (X=Bonus[1]) and (Y=Bonus[2]) then
                                  begin
                                    Sucesso := True;
                                    Inc (Player, 2);
                                  end;

          end;
          {*Mostra a letra que ele indicou*}
          SetColor (BLUE);
          ShowLetra (Resposta[0],Resposta[1],Matriz[Resposta[0],Resposta[1]],
                    Tabuleiro, Nivel, True);
          if Tabuleiro in [Tab2,Tab3] then
           begin
             SetColor (BLUE);
             ShowLetra (Resposta[2],Resposta[3],Matriz[Resposta[2],
                        Resposta[3]],Tabuleiro, Nivel, True);
           end;
          SetTextStyle (TRIPLEXFONT,HORIZDIR,2);
          if Sucesso then   {*Se acertamos*}
            begin
              MakeSound (220,100);
              Inc (Player);
              Bar (533,45,633,85);
              Rectangle (533,45,633,85);
              SetColor (CYAN);
              OutTextXy (538,50, Converte(Player));
            end
          else              {*Se nao*}
            begin
              MakeSound (520,300);
              Inc (Computer);
              Bar (6,45,106,85);
              Rectangle (6,45,106,85);
              SetColor (CYAN);
              OutTextXy (12,50, Converte(Computer));
            end;
          end;
        end
       else
         Conjunto := Conjunto + [Matriz[X,Y]];

      {*Apaga a letra que saiu*}
      Delete (Colunas, Indice, 1);
      Delete (Linhas, Indice, 1);
    until Length (Colunas) = 0;  {*Ja chegamos ao fim?*}
    {*Se o jogador conseguiu passar de quadro*}
    if ((Player >= 2*Computer) and (Tabuleiro>Tab1)) or
       ((Player >= Computer) and (Tabuleiro = Tab1)) then
      begin
        if Nivel < Nivel5 then
          Inc (Nivel)
        else
          begin
            Inc (Tabuleiro);
            Nivel := Nivel1;
          end;
        SetColor (WHITE);
        SetTextStyle (SANSSERIFFONT,HORIZDIR,3);
        OutTextXy (5,440,'Parabens, passaste mais um quadro');
        ReadKey;
        SetColor (RED);
        MakeSound (880,500);
        MakeSound (700,500);
      end
    else   {*Se nao conseguiu*}
      begin
        MakeSound (880,500);
        SetColor (WHITE);
        SetTextStyle (SANSSERIFFONT,HORIZDIR,3);
        OutTextXy (5,440, 'Perdeste');
        Delay (800);
        SetFillStyle (SOLIDFILL,GREEN);
        Bar (0,429,639,479);
        Rectangle (0,429,639,479);
        SetFillStyle (SOLIDFILL,WHITE);
        SetColor (RED);
        {*Se estivermos no tabuleiro 1 ou no 2, da-se a chance de repetir*}
        {*o quadro                                                       *}
        if Tabuleiro in [Tab1..Tab2] then
          begin
            SetColor (WHITE);
            OutTextXy (5,440,'Se desejar repetir este quadro pressione S');
            SetColor (RED);
            if UpCase (ReadKey) <> 'S' then
              Saida := True
            else
              begin
                Computer := 0;
                Player := 0;
              end;
          end;
        {*Mostra as posicoes de todas as letras*}
        for X:= 1 to Ord(Tabuleiro) + 3 do
         for Y:= 1 to Ord(Tabuleiro) + 3 do
          ShowLetra (X, Y, Matriz[X, Y], Tabuleiro, Nivel,False);
        ReadKey;
      end;
  until Saida or (Tabuleiro=Tab4);
  {*Aqui sera colocado mais tarde o codigo referente ao tabuleiro 4*}
end;


{---------------------------------------------}
{Esta e a subrotina Logo. Nao recebe variaveis}
{Tem como funcao fazer a apresentacao do jogo }
{---------------------------------------------}
procedure Logo;

var
   I: char;
   k: integer;
Begin
   {*Desenha o primeiro ecran*}
   SetBkColor(cyan);
   SetColor(yellow);
   SetTextStyle(triplexFont, HorizDir, 10);
   OutTextXY ( 60,10,'P');
   Delay(650);
   OutTextXY (137,10,'&');
   Delay(650);
   OutTextXY (227,10,'P');
   Delay(650);
   OutTextXY (367,10,'L');
   Delay(650);
   OutTextXY (433,10,'d');
   Delay(650);
   OutTextXY (503,10,'');
   SetTextStyle(triplexFont, HorizDir, 5);
   OutTextXY (200,250,'PRESENTS');
   {*Enche o ecran de circulos*}
   K:=0;
   repeat
       circle (random(640),Random(480),Random(30));
       SetColor (Random(17));
       delay (50);
       Inc(K);
   until  keypressed OR (K=200);
   if K<>200 then
      ReadKey;
   {*Desenha o segundo ecran*}
   SetFillStyle(solidfill, cyan);
   ClearDevice;
   SetColor(Yellow);
   SetTextStyle(triplexFont, HorizDir, 7);
   OutTextXY(100,60,'The');
   OutTextXY(100,120,'MindWorker');
   OutTextXY(200,200,'?!!??!!');
   SetTextStyle(triplexFont, HorizDir, 5);
   SetColor(red);
   {*Vai colocando dados sobre o que os autores do jogo fizeram*}
   OutTextXY(200,280,'PRODUCTION :');
   SetColor(blue);
   OutTextXY(150,340,'Paulo Pinto');
   OutTextXY(150,400,'Pablo Tavares');
   K:=0;
   Repeat
     Inc(K);
     Delay (50);
   Until  KeyPressed OR (K=100);
   If K<>100 Then
      ReadKey;
   Bar (140,270,639,479);
   Delay(300);
   SetColor(red);
   OutTextXY(200,280,'GRAPHICS :');
   SetColor(blue);
   OutTextXY(150,340,'Paulo Pinto');
   OutTextXY(150,400,'Pablo Tavares');
   K:=0;
   Repeat
     Inc(K);
     Delay (50);
   Until  KeyPressed OR (K=100);
   If K<>100 Then
      ReadKey;
   Bar (140,270,639,479);
   Delay(300);
   SetColor(red);
   OutTextXY(200,280,'MUSIC :');
   SetColor(blue);
   OutTextXY(150,340,'Paulo Pinto');
   OutTextXY(150,400,'Pablo Tavares');
   K:=0;
   Repeat
     Inc(K);
     Delay (50);
   Until  KeyPressed OR (K=100);
   If K<>100 Then
      ReadKey;
   Bar (140,270,639,479);
   Delay(300);
   SetTextStyle(triplexFont, HorizDir, 7);
   SetColor(Red);
   OutTextXY(60,350,'Lets Play Man...');
   K:=0;
   Repeat
     Inc(K);
     Delay (50);
   Until  KeyPressed OR (K=100);
   If K<>100 Then
      ReadKey;
end;

{-----------------------------------------}
{Esta rotina e Botao. Recebe X,Y que sao  }
{as coordenadas do botao; Espaco que e o  }
{espaco em branco a direita e a esquerda  }
{do texto do botao; Mensagem e o texto do }
{botao; Premido indica se o botao foi     }
{premido ou nao.                          }
{-----------------------------------------}
procedure Botao (x,y,
                 Espaco   : Integer;
                 Mensagem : MsgTipo;
                 Premido  : Boolean);

var
   X2     : Word;
   Saida  : Boolean;
begin
   SetFillStyle (SOLIDFILL,BLACK);
   SetTextStyle(TRIPLEXFONT,HORIZDIR,2);
   X2 := TextWidth (Mensagem)+Espaco*2;
   Bar ( X+1, Y+1, X+X2+9, Y+41);
   Saida := FALSE;
   repeat
      if Premido then
         begin
            SetColor(BLUE);
            Rectangle ( X+5, Y+5, X+X2+5, Y+35);
            Setcolor(LIGHTGRAY);
            Line ( X+3, Y+3, X+X2+7, Y+3);
            Line ( X+4, Y+4, X+X2+6, Y+4);
            Line ( X+3, Y+3, X+3, Y+37);
            Line ( X+4, Y+4,  X+4, Y+36);
            Setcolor(DARKGRAY);
            Line ( X+X2+7, Y+3, X+X2+7, Y+37);
            Line ( X+X2+6, Y+4, X+X2+6, Y+36);
            Line ( X+3, Y+37, X+X2+7, Y+37);
            Line ( X+4, Y+36, X+X2+6, Y+36);
            SetFillStyle (SOLIDFILL,CYAN);
            FloodFill( X+(X2 Div 2)+10, Y+20, BLUE);
            Setcolor(BLACK);
            OutTextXY( X+5+Espaco, Y+5,Mensagem);
            Delay(900);
            Premido := FALSE;
         end
      else
         begin
            SetColor(BLUE);
            Rectangle ( X, Y, X+X2+10, Y+40);
            Rectangle ( X+5, Y+5, X+X2+5, Y+35);
            Line ( X, Y, X+5, Y+5);
            Line ( X+X2+10, Y, X+X2+5, Y+5);
            Line ( X, Y+40, X+5, Y+35);
            Line ( X+X2+10, Y+40, X+X2+5, Y+35);
            SetFillStyle (SOLIDFILL,LIGHTGRAY);
            Floodfill( X+10, Y+3,BLUE);
            Floodfill( X+3, Y+10,BLUE);
            SetFillStyle (SOLIDFILL,CYAN);
            FloodFill( X+(X2 Div 2), Y+20,BLUE);
            SetFillStyle (SOLIDFILL,DARKGRAY);
            Floodfill( X+X2, Y+37,BLUE);
            Floodfill( X+X2+7, Y+30,BLUE);
            Setcolor(BLUE);
            OutTextXY( X+6+Espaco, Y+5,Mensagem);
            Saida := True;
         end;
   until Saida;
end;


{------------------------------------------------}
{Esta e a subrotina Ajuda. Nao recebe variaveis  }
{A sua funcao e apresentar as instruccoes do jogo}
{------------------------------------------------}
procedure  Ajuda;
var
   Input       : Text;
   Linha       : string[100];
   I,Escolha,
   Opcao       : Byte;
   X, Y,
   X1,Y1,
   X2,Y2       : Word;
   Tecla       : Char;
   Left,
   Middle,
   Right,
   Sair        : Boolean;

begin
  
  SetTextStyle (TRIPLEXFONT,HORIZDIR,2);
  ClearDevice;
  {*Abre o ficheiro*}
  Assign (Input,HelpPath);
  Reset (Input);
  I:=0;
  Sair := FALSE;
  Botao (50,425,35,'CONTINUAR',FALSE);
  Botao (350,425,62,'MENU',FALSE);
  {*Le os dados do ficheiro e printa-os no ecran*}
  while (not Eof (Input)) and (not Sair) do
   begin

     while (not eoln(input)) and (not Sair) do
       begin
        Inc(I);
        Read (Input, Linha);
        SetColor (CYAN);
        OutTextxy (17,3+(i * textheight('M')), Linha);
        delay(500);
        if (I = 19) then
        begin
          {*Obtem a resposta*}
          Opcao   := 0;
          if not IsMouse then
           begin
             X1      := 48;
             Y1      := 423;
             X2      := 245;
             Y2      := 468;
             Escolha := 1;
             SetColor (RED);
             Rectangle ( X1, Y1, X2, Y2);
             Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
             repeat
               Tecla := ReadKey;
               if Tecla = #13 then
               begin
                  case Escolha of

                      1 : Botao ( X1+2, Y1+2,35,'CONTINUAR',TRUE);

                      2 : Botao ( X1+2, Y1+2,62,'MENU',TRUE);
                  end;
                  Opcao := Escolha;
               end;
               if Tecla = #0 then
               begin
                 Tecla := ReadKey;
                 case Tecla of

                      'M' :begin            { Para Direita }
                              SetColor (BLACK);
                              Rectangle ( X1, Y1, X2, Y2);
                              Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                              if X1 < 99 then
                              begin
                                 X1      := X1+300;
                                 X2      := X2+300;
                                 Escolha := Escolha+1;
                              end
                              else
                              begin
                                 X1      := 48;
                                 X2      := 245;
                                 Escolha := 1;
                              end;
                              SetColor (RED);
                              Rectangle ( X1, Y1, X2, Y2);
                              Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                           end;

                      'K' :begin              { Para Esquerda }
                              SetColor (BLACK);
                              Rectangle ( X1, Y1, X2, Y2);
                              Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                              if X1 > 347 then
                              begin
                                 X1      := X1-300;
                                 X2      := X2-300;
                                 Escolha := Escolha-1;
                              end
                              else
                              begin
                                 X1      := 348;
                                 X2      := 545;
                                 Escolha := 2;
                              end;
                              SetColor (RED);
                              Rectangle ( X1, Y1, X2, Y2);
                              Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                            end;
                 end;
               end;
             until Opcao in [1..2];
           end
          else
           begin
             ShowCursor;
             repeat
               MouseStatus (Left,Middle,Right,X,Y);
               if Left and ((Y>=424) and (Y<=467)) then
                 case X of
                    48..245 : begin
                                Opcao := 1;
                                HideCursor;
                                Botao (50,425,35,'CONTINUAR',True);
                              end;

                   348..545 : begin
                                Opcao := 2;
                                HideCursor;
                                Botao (350,425,62,'MENU',True);
                              end;
                 end;
             until Opcao in [1..3];
           end;

           if Opcao = 2 then
              Sair := TRUE
           else
              Sair := FALSE;
           SetFillStyle ( SolidFill,BLACK);
           bar (0,0,639,420);
            I := 0;
        end;
       end;
       ReadLn(Input);
     end;
  if not Sair then
  begin
     SetFillStyle ( SolidFill,BLACK);
     Bar (0,420,639,479);
     Botao (75,425,200,'MENU',FALSE);
     if not IsMouse then
       begin
         Tecla := ReadKey;
         if Tecla = #13 then
           Botao (75,425,200,'MENU',FALSE);
       end
     else
      begin
        Saida := False;
        ShowCursor;
        repeat
          MouseStatus (Left,Middle,Right,X,Y);
          if Left and ((X>=75) and (X<=542)) and
             ((Y>=425) and (Y<=464)) then
             begin
               HideCursor;
               Botao (75,425,200,'MENU',True);
               Saida := True;
             end
        until Saida;
      end;
  end;
  I := 0;
  {*Fecha o ficheiro*}
  Close (Input);
end;



{--------------------------------------------------------------}
{Esta rotina e Sair. Recebe como parametro uma variavel boolean}
{A sua funcao e certificar-se  se o utilizador quer realmente  }
{sair, em caso afirmativo o seu valor e mudado para true       }
{--------------------------------------------------------------}
procedure  Sair (var Saida:Boolean);
var
   Tecla    : Char;
   X, Y,
   X1,Y1,
   X2,Y2,
   Escolha,
   Opcao    : Word;
   Left,
   Middle,
   Right    : Boolean;

begin
  {*Desenha no ecran a informacao para o utilizador*}
  SetFillStyle (SolidFill,BLACK);

  Bar (78,135,232,327);
  Botao (80,173,48,'SAIR',FALSE);
  Botao (80,258,33,'VOLTAR',FALSE);

  {*Obtem a resposta*}
  Opcao   := 0;
  if not IsMouse  then
   begin
      X1      := 79;
      Y1      := 172;
      X2      := 231;
      Y2      := 214;
      Escolha := 1;
      SetColor (RED);
      Rectangle ( X1, Y1, X2, Y2);
      Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
      repeat
        Tecla := ReadKey;
        if Tecla = #13 then
         begin
           case Escolha of

              1 : Botao ( X1+1, Y1+1,48,'SAIR',TRUE);

              2 : Botao ( X1+1, Y1+1,33,'VOLTAR',TRUE);

           end;
           Opcao := Escolha;
         end;
         if Tecla = #0 then
          begin
            Tecla := ReadKey;
            case Tecla of
               'H' :begin            { Para cima }
                      SetColor (BLACK);
                      Rectangle ( X1, Y1, X2, Y2);
                      Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                      if Y1 > 172 then
                         begin
                            Y1      := Y1-85;
                            Y2      := Y2-85;
                            Escolha := Escolha-1;
                         end
                      else
                         begin
                            Y1      := 257;
                            Y2      := 299;
                            Escolha := 2;
                         end;
                      SetColor (RED);
                      Rectangle ( X1, Y1, X2, Y2);
                      Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                    end;

             'P' :  begin              { Para Baixo }
                      SetColor (BLACK);
                      Rectangle ( X1, Y1, X2, Y2);
                      Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                      if Y1 < 257 then
                         begin
                            Y1      := Y1+85;
                            Y2      := Y2+85;
                            Escolha := Escolha+1;
                         end
                      else
                         begin
                            Y1      := 172;
                            Y2      := 214;
                            Escolha := 1;
                         end;
                      SetColor (RED);
                      Rectangle ( X1, Y1, X2, Y2);
                      Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                    end;
            end;
          end;
      until Opcao in [1..2];
   end
  else
   begin
     ShowCursor;
     repeat
       MouseStatus (Left,Middle,Right,X,Y);
       if Left and ((X>=80) and (X<=230)) then
          case Y of
             173..213 : begin
                          Opcao := 1;
                          Botao (80,173 ,48,'SAIR',TRUE);
                        end;

             258..298 : begin
                          Opcao := 2;
                          Botao (80,258,33,'VOLTAR',TRUE);
                        end;
          end;
     until Opcao in [1..3];
     HideCursor;
   end;

  if Opcao = 1 then
     Saida := True;

  ClearDevice;
end;



{-----------------------------------------}
{Esta rotina e Menu. Nao recebe variaveis }
{Tem como funcao determinar qual a escolha}
{do utilizador e devolver o resultado     }
{correspondente                           }
{-----------------------------------------}
function Menu:Byte;
var
   Opcao,
   Escolha : Byte;
   Tecla   : Char;
   X, Y,
   X1,Y1,
   X2,Y2   : Word;
   Left,
   Middle,
   Right   : Boolean;


begin
  {*Desenha no ecran a informacao para o utilizador*}
  ClearDevice;
  SetBkColor (BLACK);
  SetFillStyle (SOLIDFILL,WHITE);
  SetTextStyle (GOTHICFONT,HORIZDIR,8);
  SetColor (DARKGRAY);
  OutTextXy (24,10,'The Mind Worker');
  OutTextXy (14,355,'Make Your Choice');
  SetColor (YELLOW);
  OutTextXy (20,5,'The Mind Worker');
  OutTextXy (10,350,'Make Your Choice');
  SetTextStyle (SANSSERIFFONT,HORIZDIR,5);
  Botao (80,135,40,'JOGAR',FALSE);
  Botao (80,210,40,'AJUDA',FALSE);
  Botao (80,285,48,'SAIR',FALSE);
  SetTextStyle (TRIPLEXFONT,HORIZDIR,6);
  SetColor (DARKGRAY);
  OutTextXy (359,125,'Winners');
  OutTextXy (334,200,'Don''t Use');
  OutTextXy (384,275,'Drugs');
  SetColor (BLUE);
  OutTextXy (355,120,'Winners');
  OutTextXy (330,195,'Don''t Use');
  OutTextXy (380,270,'Drugs');
    {*Obtem a resposta ate ela ser valida*}
  Opcao := 0;
  if not IsMouse then
   begin
     X1      := 79;
     Y1      := 134;
     X2      := 231;
     Y2      := 176;
     Escolha := 1;
     SetColor (RED);
     Rectangle ( X1, Y1, X2, Y2);
     Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
     repeat
       Tecla := ReadKey;
       if Tecla = #13 then
         begin
           case Escolha of

               1 : Botao ( X1+1, Y1+1,40,'JOGAR',TRUE);

               2 : Botao ( X1+1, Y1+1,40,'AJUDA',TRUE);

               3 : Botao ( X1+1, Y1+1,48,'SAIR',TRUE);

           end;
           Opcao := Escolha;
         end;
       if Tecla = #0 then
         begin
           Tecla := ReadKey;
           case Tecla of
              'H' :  begin            { Para cima }
                        SetColor (BLACK);
                        Rectangle ( X1, Y1, X2, Y2);
                        Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                        if Y1 > 134 then
                          begin
                            Y1      := Y1-75;
                            Y2      := Y2-75;
                            Escolha := Escolha-1;
                          end
                        else
                          begin
                             Y1      := 284;
                             Y2      := 326;
                             Escolha := 3;
                          end;
                        SetColor (RED);
                        Rectangle ( X1, Y1, X2, Y2);
                        Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                     end;

               'P' : begin              { Para Baixo }
                       SetColor (BLACK);
                       Rectangle ( X1, Y1, X2, Y2);
                       Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                       if Y1 < 284 then
                         begin
                            Y1      := Y1+75;
                            Y2      := Y2+75;
                            Escolha := Escolha+1;
                         end
                       else
                         begin
                            Y1      := 134;
                            Y2      := 176;
                            Escolha := 1;
                         end;
                       SetColor (RED);
                       Rectangle ( X1, Y1, X2, Y2);
                       Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                     end;
           end;
         end;
     until Opcao in [1..3];
   end
  else
   begin
     ShowCursor;
     repeat
       MouseStatus (Left,Middle,Right,X,Y);
       if Left and ((X>=80) and (X<=230)) then
          case Y of
             135..175 : begin
                          Opcao := 1;
                          HideCursor;
                          Botao (80,135 ,40,'JOGAR',TRUE);
                        end;

             210..250 : begin
                          Opcao := 2;
                          HideCursor;
                          Botao (80,210,40,'AJUDA',TRUE);
                        end;

             285..325 : begin
                          Opcao := 3;
                          HideCursor;
                          Botao (80,285,48,'SAIR',TRUE);
                        end;
          end;
     until Opcao in [1..3];
   end;

  Menu :=Opcao;
end;


{-------------------------------------------}
{ Esta e a rotina que permite ao utilizador }
{  escolher o dispositivo de input          }
{-------------------------------------------}

function  MouseChoice: Boolean;
var
   Tecla    : Char;
   X1,Y1,
   X2,Y2,
   Escolha,
   Opcao    : Word;

begin
  {*Desenha no ecran a informacao para o utilizador*}
  SetColor (YELLOW);
  SetTextStyle (TRIPLEXFONT,HORIZDIR,4);
  OutTextXy (50,100,'O que deseja usar no programa?');


  Botao (350,300,48,'RATO',FALSE);
  Botao (100,300,33,'TECLADO',FALSE);

  {*Obtem a resposta*}
  X1      := 98;
  Y1      := 298;
  X2      := 264;
  Y2      := 342;
  Escolha := 1;
  Opcao   := 0;
  SetColor (RED);
  Rectangle ( X1, Y1, X2, Y2);
  Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
  repeat
    Tecla := ReadKey;
    if Tecla = #13 then
       begin
          case Escolha of

             1 : Botao ( X1+1, Y1+1,33,'TECLADO',TRUE);

             2 : Botao ( X1+1, Y1+1,48,'RATO',TRUE);

          end;
          Opcao := Escolha;
       end;
    if Tecla = #0 then
       begin
          Tecla := ReadKey;
          case Tecla of
             'M' :begin            { Para Direita }
                     SetColor (BLACK);
                     Rectangle ( X1, Y1, X2, Y2);
                     Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                     if X1 < 348 then
                        begin
                           X1      := X1 + 250;
                           X2      := X2 + 240;
                           Escolha := 2;
                        end
                     else
                        begin
                           X1      := 98;
                           X2      := 264;
                           Escolha := 1;
                        end;
                     SetColor (RED);
                     Rectangle ( X1, Y1, X2, Y2);
                     Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                  end;

             'K' :begin              { Para Esquerda }
                     SetColor (BLACK);
                     Rectangle ( X1, Y1, X2, Y2);
                     Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                     if X1 > 98 then
                        begin
                           X1      := X1 - 250;
                           X2      := X2 - 240;
                           Escolha := 1;
                        end
                     else
                        begin
                           X1      := 348;
                           X2      := 504;
                           Escolha := 2;
                        end;
                     SetColor (RED);
                     Rectangle ( X1, Y1, X2, Y2);
                     Rectangle ( X1-1, Y1-1, X2+1, Y2+1);
                  end;
          end;
       end;
  until Opcao in [1..2];

  if Opcao = 1 then
      MouseChoice := False
  else
      MouseChoice := True;
end;

{---------------------------------------------}
{Esta rotina e FimDeJogo. Nao recebe variaveis}
{Tem como funcao desligar o modo grafico seja }
{qual for a razao da terminacao do programa   }
{---------------------------------------------}
procedure FimDeJogo;far;
begin
  {*Restaura a variavel ExitProc e desliga o sistema grafico*}
  ExitProc := SafeExit;
  CloseGraph;
end;

{------------------------------------}
{Este e o bloco principal do programa}
{------------------------------------}
begin
   {Uso da variavel que indica que procedimento chamar na terminacao}
   {do programa, para permitir que o sistema grafico seja sempre desligado}
   SafeExit := ExitProc;
   ExitProc := @FimDeJogo;

   {Inicializacao do sistema grafico para VGA 640x480}
   GraphDriver := VGA;
   GraphMode := VGAHI;
   InitGraph (GraphDriver, GraphMode,BgiPath);
   if GraphResult<>GrOk then
     begin
       WriteLn ('Erro na inicializacao grafica do programa');
       Halt (1);
     end;


{   if InitMouse <> 0 then
       IsMouse := MouseChoice
   else
       IsMouse := False;}
       IsMouse := True;


    {Bloco de Controlo do Jogo}
    Saida := False;
    repeat
      case Menu of
         1 : Jogar;

         2  : Ajuda;

         3  : Sair (Saida);
      end;
    until Saida;
end.