{ Esta e a unit que contem as rotinas do rato usadas pelo programa}
unit Mouse;
interface

var
    MouseButtons : Byte; { Variavel que contem o numero de buttoes do rato }

{ Rotinas acessiveis pelos programas }
function  InitMouse:Byte;
procedure ShowCursor;
procedure HideCursor;
procedure MouseStatus (var Left,Middle,Right:Boolean; var X,Y:Word);

implementation
uses Dos, Crt;

{-------------------------------------------------------------}
{ Esta e a rotina que tem como dever inicializar o rato, a    }
{  interrupcao devolve em AX os valores: 0->Erro; -1->Sucesso.}
{ Como a funcao tem que colocar em AX o valor de retorno se   }
{  este for inferior a doubleword, nao e preciso mover o valor}
{  devolvido pela interrupcao.                                }
{-------------------------------------------------------------}
function InitMouse:Byte; assembler;
asm
    mov    ax, 0
    int    $33
    mov    MouseButtons, Bl
end;

{-------------------------------------}
{ Esta rotina mostra o cursor no ecra }
{-------------------------------------}
procedure ShowCursor; assembler;
asm
   mov   ax, 1
   int   $33
end;


{--------------------------------------}
{ Esta rotina esconde o cursor no ecra }
{--------------------------------------}

procedure HideCursor; assembler;
asm
   mov   ax, 2
   int   $33
end;

{-----------------------------------------}
{ Esta rotina verifica o estado do rato e }
{  devolve os valores respectivos .       }
{ Left, Middle e Right indicam se estes   }
{  butoes estao ou nao premidos.          }
{ X e Y indicam a posicao do cursor       }
{-----------------------------------------}
procedure MouseStatus (var Left,Middle,Right:Boolean; var X,Y:Word);
var
   Reg : Registers;

begin
  Reg.Ax := 3;
  Intr ($33,Reg);
  X := Reg.Cx;
  Y := Reg.Dx;
  { Vamos ver qual o estado dos butoes }
  if (Reg.bx and 1) = 1  then
        Left := True
  else
        Left := False;
  if (Reg.bx and 4) = 4  then
        Middle := True
  else
        Middle := False;
  if (Reg.bx and 2) = 2  then
        Right := True
  else
        Right := False;
end;

end.

